package farm.ants.plugins;
import farm.simulator.*;
import java.awt.geom.*;
import java.rmi.*;
import java.util.*;

/**
 * This class describes an object in the environment
 * <p>
 * Created: Tue Jul  9 14:16:09 2002
 *
 * @author Roger Mailler
 */
public class ObjectModel  implements Comparable{
    
    protected FarmPlugIn fpi = null;
    public ObjectModel(FarmPlugIn FPI, String n) {
	fpi = FPI;
	setName(n);
    }

    public ObjectModel(FarmPlugIn FPI, String n, float X, float Y) {
	fpi = FPI;
	setName(n);
	setPoint(new Point2D.Float(X,Y));
	//setX(X);
	//setY(Y);
    }

    Point2D.Float pt = null;

    public Point2D.Float getPoint(boolean vol) {
	if (pt == null || vol) {
            Object prop = fpi.getProperty(name + ":loc");
            if(prop != null){
                StringTokenizer tok = new StringTokenizer((String) prop, ",");
                pt = new Point2D.Float(Float.parseFloat(tok.nextToken()), Float.parseFloat(tok.nextToken()));
            }
            else
                pt = null;
	}      	
	return pt;
    }

    /**
       * Set the value of x.
       * @param v  Value to assign to x.
       */
    public void setPoint(Point2D.Float ptf) {
	fpi.setProperty(name + ":loc", ptf.getX() + "," + ptf.getY());
	this.pt = ptf;
    }




    //float x = -1.0f;
    
    /**
       * Get the value of x.
       * @return Value of x.
       */
    /*    public float getX(boolean vol) {
	float val = x;
	if(x == -1.0f || vol) {
	    Object prop = fpi.getProperty(name + ":x");
	    if(prop != null)
		x = ((Float) prop).floatValue();
	    else
		x = -1f;
	}      	
	if(val != x) dirty = true;
	return x;
	}*/
    
    /**
       * Set the value of x.
       * @param v  Value to assign to x.
       */
    /*    public void setX(float  v) {
	fpi.setProperty(name + ":x", new Float(v));
	this.x = v;
	}*/
    

    //float y = -1;
    
    /**
       * Get the value of y.
       * @return Value of y.
       */
    /*public float getY(boolean vol) {
	float val = y;
	if(y == -1 || vol) {
	    Object prop = fpi.getProperty(name + ":y");
	    if(prop != null)
		y = ((Float) prop).floatValue();
	    else
		y = -1f;
	}      	
	if(val != y) dirty = true;
	return y;
	}*/
    
    /**
       * Set the value of y.
       * @param v  Value to assign to y.
       */
    /*public void setY(float  v) {	
	fpi.setProperty(name + ":y", new Float(v));
	this.y = v;
	}*/
    
    String name;
    
    /**
       * Get the value of name.
       * @return Value of name.
       */
    public String getName() {return name;}
    
    /**
       * Set the value of name.
       * @param v  Value to assign to name.
       */
    public void setName(String  v) {this.name = v;}
    

    boolean dirty = true;
    
    /**
       * Get the value of dirty.
       * @return Value of dirty.
       */
    public boolean getDirty() {return dirty;}
    
    /**
       * Set the value of dirty.
       * @param v  Value to assign to dirty.
       */
    public void setDirty(boolean  v) {this.dirty = v;}
    



    public int compareTo(Object o) {
	//sort on x then y of the point
	ObjectModel oM = (ObjectModel) o;
	if(this.pt.getX() > oM.getPoint(false).getX()){
	    return 1;
	}
	else if(this.pt.getX() < oM.getPoint(false).getX()){
	    return -1;
	}
	else{
	    if(this.pt.getY() > oM.getPoint(false).getY()){
		return 1;
	    }
	    else if(this.pt.getY() < oM.getPoint(false).getY()){
		return -1;
	    }
	    else{
		return 0;
	    }
	}
    }

} // ObjectModel
