package farm.metagent;

/**
 * The <code>JProf</code> class provides access to the capjprof agent
 * for the JVMPI profiler interface.
 * To activate the agent start the JVM with <code>java -Xruncapjprof ...</code>
 *
 * @author  Jesper Goertz jesper.goertz@capgemini.dk
 */
public class JProf {
  /**
   * Gets cpu time for the current thread
   *
   * @return  cpu time in nanoseconds or 0 if agent not active
   */
  public static native long getThreadTime();

  static {
	try {
		System.loadLibrary("capjprof");
	} catch (Error e) {
		System.err.println(e);
		System.err.println("java.library.path = " + System.getProperty("java.library.path"));
		e.printStackTrace();
	}
  }
}
