/**
 */

package farm.metagent;

import java.rmi.Remote;
import java.rmi.RemoteException;

import farm.simulator.PlugIn;

/**
 * The general metagent interface which is available to the simulator.
 * A minimal farm-compliant metagent must implement each of these
 * methods.
 * @see FarmMetAgent
 */
public interface MetAgent extends Remote, PlugIn  {

    public void registerMetAgent(MetAgent agent) throws RemoteException;
    public void unregisterMetAgent(MetAgent agent) throws RemoteException;

    public void acceptMessage(Message msg) throws RemoteException;
    public boolean hasAgent(String name) throws RemoteException;

    public void setBaselineCPUMetric(double m) throws RemoteException;

    public String getMetAgentName() throws RemoteException;
}
